ghc-8.0.2: The GHC API

Safe Haskell | None
Language | Haskell2010

FunDeps

# Documentation

data FunDepEqn loc Source #

Constructors

FDEqn |
Fields fd_qtvs :: [TyVar] fd_eqs :: [Pair Type] fd_pred1 :: PredType fd_pred2 :: PredType fd_loc :: loc

pprEquation :: FunDepEqn a -> SDoc Source #

improveFromInstEnv :: InstEnvs -> (PredType -> SrcSpan -> loc) -> PredType -> [FunDepEqn loc] Source #

improveFromAnother :: loc -> PredType -> PredType -> [FunDepEqn loc] Source #

checkInstCoverage :: Bool -> Class -> [PredType] -> [Type] -> Validity Source #

checkFunDeps :: InstEnvs -> ClsInst -> [ClsInst] Source #

pprFundeps :: Outputable a => [FunDep a] -> SDoc Source #